Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 395363 - x11-proto/xproto: add x32 support (fix building of pkgs like x11-libs/libXmu)
Summary: x11-proto/xproto: add x32 support (fix building of pkgs like x11-libs/libXmu)
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Gentoo X packagers
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: x32
  Show dependency tree
 
Reported: 2011-12-20 13:52 UTC by Sergei Trofimovich
Modified: 2012-06-10 09:53 UTC (History)
3 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
patch against latest x11-proto/xproto (quite invasive) (xproto-7.0.22-no-LONG64-on-x32.patch,1.09 KB, text/plain)
2011-12-20 13:52 UTC, Sergei Trofimovich
Details
patch against latest x11-libs/libXt (similar to above) (libXt-1.1.1-no-LONG64-on-x32.patch,504 bytes, patch)
2011-12-20 13:57 UTC, Sergei Trofimovich
Details | Diff
patch against latest x11-proto/xproto (less invasive this time) (0001-Xmd.h-Treat-__ILP32__-targets-as-LONG32-ones.patch,1.25 KB, patch)
2012-06-06 18:49 UTC, Sergei Trofimovich
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Sergei Trofimovich gentoo-dev 2011-12-20 13:52:37 UTC
Created attachment 296445 [details]
patch against latest x11-proto/xproto (quite invasive)

/bin/sh ../libtool --silent --tag=CC   --mode=compile x86_64-pc-linux-gnu-gcc -std=gnu99 -DHAVE_CONFIG_H -I. -I/var/tmp/portage/x11-libs/libXmu-1.1.0/work/libXmu-1.1.0/src -I..  -I/var/tmp/portage/x11-libs/libXmu-1.1.0/work/libXmu-1.1.0/include -I/var/tmp/portage/x11-libs/libXmu-1.1.0/work/libXmu-1.1.0/include/X11/Xmu -DBITMAPDIR=\"/usr/include/X11/bitmaps\" -D_BSD_SOURCE  -Wall -Wpointer-arith -Wstrict-prototypes -Wmissing-prototypes -Wmissing-declarations -Wnested-externs -fno-strict-aliasing -Wbad-function-cast -Wformat=2 -Wold-style-definition -Wdeclaration-after-statement   -O2 -pipe -c -o ExtAgent.lo /var/tmp/portage/x11-libs/libXmu-1.1.0/work/libXmu-1.1.0/src/ExtAgent.c
/var/tmp/portage/x11-libs/libXmu-1.1.0/work/libXmu-1.1.0/src/EditresCom.c: In function 'HandleToolkitErrors':
/var/tmp/portage/x11-libs/libXmu-1.1.0/work/libXmu-1.1.0/src/EditresCom.c:998:2: warning: format not a string literal, argument types not checked [-Wformat-nonliteral]
/var/tmp/portage/x11-libs/libXmu-1.1.0/work/libXmu-1.1.0/src/EditresCom.c: In function '_XEditresGetStringValues':
/var/tmp/portage/x11-libs/libXmu-1.1.0/work/libXmu-1.1.0/src/EditresCom.c:2198:6: error: duplicate case value
/var/tmp/portage/x11-libs/libXmu-1.1.0/work/libXmu-1.1.0/src/EditresCom.c:2194:6: error: previously used here
Comment 1 Sergei Trofimovich gentoo-dev 2011-12-20 13:57:51 UTC
Created attachment 296447 [details, diff]
patch against latest x11-libs/libXt (similar to above)

Looks like (out-of-sync) libXt's copy is the same.
Comment 2 Chí-Thanh Christopher Nguyễn gentoo-dev 2011-12-20 15:13:24 UTC
What is the upstream status of this patch?
Comment 3 Sergei Trofimovich gentoo-dev 2011-12-20 16:15:21 UTC
didn't show it anyone
Comment 4 Sergei Trofimovich gentoo-dev 2011-12-20 17:13:16 UTC
Sent an email. The battle has begun.
In short, __LP64__ is a bad guard for non-gcc.

http://lists.x.org/archives/xorg-devel/2011-December/027949.html
Comment 5 Sergei Trofimovich gentoo-dev 2011-12-21 05:39:02 UTC
@x11: What do you think of conditionally patching both things:

    has x32 $(get_all_abis) && epatch

not exactly nice, but quite safe.
Comment 6 Sergei Trofimovich gentoo-dev 2012-06-06 18:49:07 UTC
Created attachment 314459 [details, diff]
patch against latest x11-proto/xproto (less invasive this time)

Updated patch to use recently introduced __ILP32__.

Sent upstream in the tail of flamy thread:
    http://www.mail-archive.com/xorg-devel@lists.x.org/msg27303.html
Comment 7 Xavier Miller gentoo-dev 2012-06-08 09:10:47 UTC
Patching /usr/include/X11/Xmd.h worked for me.
This file comes from x11-proto/xproto
Comment 8 James Cloos 2012-06-10 09:23:38 UTC
I pushed the __ILP32__ version of the patch (as in attachment #314459 [details, diff] here) to the x11proto repo.

It should be in xproto-7.0.24 when that gets released.
(I can not predict an ETA.)
Comment 9 Chí-Thanh Christopher Nguyễn gentoo-dev 2012-06-10 09:53:42 UTC
Fixed in 7.0.23-r1